<template>
  <!-- Подсказка -->
  <el-tooltip
    :enterable="false"
    content="Процент инвентаря от всего указанного инвентаря, который должен набрать программатик."
    placement="top"
    effect="light"
  >
    <!-- Форма -->
    <el-form-item label="Процент от инвентаря">
      <!-- Поле ввода процента -->
      <el-input-number
        id="number"
        v-model="percentInventoryNeed"
        @change="eventInventoryNeed(percentInventoryNeed)"
        :max="100"
        :min="0"
        size="mini"
      />
    </el-form-item>
  </el-tooltip>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "../common/ComponentMixin";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";

/**
 * Компонент ввода процента набора инвентаря.
 */
@Component
export default class PercentInventoryNeed extends Mixins(ComponentMixin) {
  // Процент нужного инвентаря
  private percentInventoryNeed = 0;
  // Параметры
  private parameters: MediaPlanParameters | null = null;

  /**
   * Метод срабатывает сразу после представления.
   */
  protected created(): void {
    // Подписываемся на событие получения параметров автоматической расстановки медиаплана
    this.subscribe(
      "media-plan-parameters-response-from-parent",
      this.onMediaPlanParametersResponse
    );
  }

  /**
   * Метод получения пареметров медиаплана и нужный процент набора инвентаря.
   * @param parameters
   */
  private onMediaPlanParametersResponse(parameters: MediaPlanParameters): void {
    this.parameters = parameters;
    this.percentInventoryNeed = parameters.percentInventoryNeed;
  }

  /**
   * Метод срабатывает после ввода.
   * @param changeInventory
   */
  private eventInventoryNeed(changeInventory: number): void {
    if (!this.parameters) return;
    this.parameters.percentInventoryNeed = changeInventory;
  }
}
</script>

<style lang="scss">
#role {
  background-color: black;
}
#number {
  .el-input-number__decrease {
    display: none !important;
  }

  [role="button"] {
    cursor: not-allowed;
    pointer-events: none;
  }
  .el-input-number__increase {
    .el-icon-plus:before {
      content: "%" !important;
      color: #000000 !important;
    }
  }
}
</style>
